TypeError: no implicit conversion of XXXX into string

09/22/2017 12:23 AM - Anon92929 (Anon Ymous)

Status: Rejected   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4:

UNKNOWN

Description

This causes SO MANY ISSUES! Instead of CRASHING, why doesn't it just apply the .to_s operator in this case???

Related issues:

Has duplicate Ruby - Bug #14589: "No implicit conversion of XXX to string" as... Rejected

History

#1 - 09/22/2017 03:58 AM - shevegen (Robert A. Heiler)

This causes SO MANY ISSUES!

 If you build up a String such as:

x = 42

y = # String here

 Then you can use:

y = "The answer to everything is #{x}"

 For global variables this is even shorter, though global variables

are not very pretty:

$x = 42 # => 42

y = "yo there #$x" # => "yo there 42"

 In the above, you do not have to manually use .to_s.

Instead of CRASHING

 It does not "crash". It raises a specific error.

I think it was once explained why the behaviour is the way it is; I

may not correctly remember though so I don't speculate. (I was thinking

of error detection in code being harder.)

The recommended way is to use "" with #{} for variables, or any of

the alternative variants (the ones with % come to mind but I think

#{} is easier to understand than the % variants; just that you get

more control via % string formatting e. g. if you need some leading

0 to some float value or something, in one go).

#2 - 09/22/2017 04:40 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Feedback

Anon92929 (Anon Ymous) wrote:

This causes SO MANY ISSUES! Instead of CRASHING, why doesn't it just apply the .to_s operator in this case???

 What is "this case"?
#3 - 09/26/2017 11:34 AM - sbhatore (Siddharth Bhatore)

I don't understand the problem clearly. Can you explain it ?

#4 - 03/08/2018 05:24 AM - nobu (Nobuyoshi Nakada)

- Status changed from Feedback to Rejected

Seems satisfied.

#5 - 03/08/2018 07:40 AM - Anon92929 (Anon Ymous)

https://bugs.ruby-lang.org/issues/14589

Not satisfied.

#6 - 03/08/2018 08:14 AM - Anon92929 (Anon Ymous)

It does not "crash". It raises a specific error.

 Halting executing while raising an error is called 'crashing' to most people.

#7 - 03/31/2018 10:39 AM - nobu (Nobuyoshi Nakada)

- Has duplicate Bug #14589: "No implicit conversion of XXX to string" asserion should be handled with an explicit string conversion, and it should be a

warning not an assertion added
